
#ifndef Botline_H_
#define Botline_H_

#include "Arduino.h"
#include "stdint.h"

// #include "EasySonar.h"
//#include "EasyMotor.h"
//#include <SPI.h>
//#include "nrf24l01/RF24.h"
//#include <Servo.h>
#include <SoftwareSerial.h>
///////////////////////////////////////////////////////////
////define for I/O Pins////////////////////////////////////
#define _BotlineIO										///
#define leftline_pin        2							///
#define rightline_pin       0							///
#define centerline_pin      1	
#define lineSensor_enable   A3

// pin and variable declared for LDR.
#define lightSensor_enable A5
//--------------------------//

// pin define and declared for LDR.
//--------------------------//
#define leftlinelight_pin        3						///
#define rightlinelight_pin       5						///
#define centerlinelight_pin      4	


//-----------------------------//

#define leftline_pin2       
#define rightline_pin2			              			///
//#define battery_monitor_pin 4     					///
#define SR04_Trig             4							///
#define SR04_Echo             3							///
//#define Servo1_pin           11                         ///
///////////////////////////////////////////////////////////

//define for EasybotNano Board with L9110S Driver
#define leftMotor_pinA    5          //_pinB1A   ///
#define leftMotor_pinB    6          //_pinB1B      ///

#define rightMotor_pinA   9          //_pinB1A      ///
#define rightMotor_pinB   10         //_pinB1B      ///
                 ///
/*
//define for NanoBoard with L298/L293 Driver ///
#define leftMotorDir_pin      9      //_pinB1A       ///
#define leftMotorPWM_pin      6      //_pinB1B       ///
#define rightMotorDir_pin     10     //_pinB1A       ///
#define rightMotorPWM_pin     11       //_pinB1B     ///
*/


 														///
												///
	
////////////////////////////////////////////////////////

////define for action paramet er
#define Right_angle           0   //angle for Head Serov
#define Left_angle            180
#define Center_angle          90
#define speed_forward         100  //speed (%)
#define lane_adjust           20  //20% speed adjust for lane control
#define turn_duration_time    1200   //turn for 1200ms           
#define deadband_time         50    //gap time btw reverse direction, microseconds
#ifndef line_detect
#define line_detect     	  400   //default threshold value for line detection              ///Default threshold for line detection is 200, if value from sensor > 200 or < 200, the line sensor status is detected or not detected
#endif
#define linefollow_adj        80      //adjust volume for speed control (%)




#define LEFT                   1
#define RIGHT                  -1
#define CENTER                 0
#define BLACK                  1
#define WHITE                  0



#define LEFTSENSOR            leftline_pin
#define RIGHTSENSOR           rightline_pin
#define CENTERSENSOR          centerline_pin
  #ifndef LINE_COLOR			
  #define LINE_COLOR            BLACK      
  #endif        ///default setting is black line   -> #define LINE_COLOR  WHITE  in the Sketch before #include "Easybot.h" to set line to WHITE
// #define BT                    SoftSerial
 #define BT_Tx_Pin 7               
 #define BT_Rx_Pin 8
 
// LDR SENSORS VALUES DECLARED.
//-----------------------------------//
#define LEFTSENSOR            leftlinelight_pin
#define RIGHTSENSOR           rightlinelight_pin
#define CENTERSENSOR          centerlinelight_pin
//-----------------------------------//



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class Botlineuno //: public SoftwareSerial
{//: public EasyMotor  
public: 	

  //  Botlineuno():  RightMotor(rightMotor_pinA,rightMotor_pinB), LeftMotor(leftMotor_pinA,leftMotor_pinB), Distance(SR04_Trig,SR04_Echo)//, BT(BT_RX_Pin,BT_TX_Pin)
//	 {} //initializer list for objects using within this Class

  //void begin();                          // set Robot Head to Centor, looking to front,   
    void moveForward(int speed);           // move forward function, Hàm chạy thẳng 
    void moveForward(int Leftspeed,int rightspeed);  // move forward with manual adjust Left, Right Wheel Speed || Hàm chạy thẳng với tham số bánh trái và phải tùy chỉnh
    void moveBack(int speed);            //  
    void moveRight(int speed);           // move to the right  || Hàm chạy xiêng về bên phải
    void moveLeft(int speed);            // move to the left   || Hàm chạy xiêng về bên trái
 	void stop();						 // stop the robot       || Hàm dừng robot
	void turnRight(int speed);           // turn to the right   || Quay robot sang phải 
	void turnRight(int speed,int time);  //turn to the right, time interval is 100ms <-> const angle
	void turnLeft(int speed);            //turn robot to the left || Quay robot sang trái
	void turnLeft(int speed,int time);   //turn to the left, time interval is 100ms <-> const angle
  void setup_lineSensor(int color, int threshold_detect);
	
	// a void value and name is created for LDR.
	void setup_lightSensor(int color, int threshold_detect);
	//------------------------------------------------------//
	
	
	int  readSensor(int channel);        ///Read line sensor with customized channel, return raw value, Channel is LEFTSENSOR, RIGHTSENSOR, CENTERSENSOR
	
	// a varable and value is declared for LDR.
	int  readLightSensor(int channel); 
	//------------------------//
	
	
	
	bool leftSensor();                   //Read sensor detection, return 1 if detect line, return 0 if not detect line
	bool rightSensor();                  //Read Right line sensor, return 1 if detect line, return 0 if not detect line
	bool centerSensor();				 //Read Center line Sensor, return 1 if detect line, return 0 if not detect line
    int readSonar();            		 ///read the distance || Đọc khoảng cách ex: int khoangcach = robot.readSonar();
	
	
	// declaring LDR function calls.
	
	bool leftLightSensor();                   //Read sensor detection, return 1 if detect line, return 0 if not detect line
	bool rightLightSensor();                  //Read Right line sensor, return 1 if detect line, return 0 if not detect line
	bool centerLightSensor();				 //Read Center line Sensor, return 1 if detect line, return 0 if not detect line
	

private:
  // EasyMotorL9110 RightMotor;
  // EasyMotorL9110 LeftMotor;
//   EasySonar Distance;
   int _LINE_COLOR = BLACK;
   int _line_detect = 400; 
 //  SoftwareSerial BT; 
 
};



#endif
